/* Estrela-de-Fogo com 256 cores, manipulacao da palheta e menos bugs. */
// VER modf

#include <graphics.h>
#include <conio.h>
#include <stdio.h>
#include <math.h>                    // M_PI, cos, sin, ...

#define COMPRVETOR 5

enum eGamaCores { MONOCROM, VERMELHOS };  // seleciona qual as cores da palheta



/* Usado para selecionar um modo grafico de um driver de usuario
****************************************************************************/
int huge Detect2 ()
{
	return ( 2 );

} /////// Detec2 ///////



/* Mostra aviso na tela e inicializa o modo 640x480x256.
****************************************************************************/
void Inicializa ()
{
	clrscr ();
	puts ("Demo Estrela-de-Fogo.\n\n");
	puts ("Tecle qualquer tecla para comecar e ESC para sair.");
	getch ();

	int
		GrDriver = DETECT,
		GrMode;

	installuserdriver ( "svga256", Detect2 );
	initgraph (&GrDriver, &GrMode, "");
	setgraphmode ( 2 );

	moveto ( getmaxx () / 2, getmaxy () /2 );

} /////// Inicializa ////////



/* Altera a palheta: 64 a 128 para branco ou para tons de vermelho.
****************************************************************************/
void Altera_Palheta ( eGamaCores Faixa )
{
	int
		Conta = 64;

	if ( Faixa == VERMELHOS )
		for ( ; Conta < 128; Conta ++ )
			setrgbpalette ( Conta , Conta - 64, 0, 0 );
	else
		for ( ; Conta < 128; Conta ++ )
			setrgbpalette ( Conta , 63, 63, 63 );

} /////// Altera_Palheta ///////



/* Retorna a parte fracionaria de um numero do tipo DOUBLE.
****************************************************************************/
inline double Frac ( double Numero )
{
	long
		NInteiro = (long) Numero;

	return ( (double) Numero - NInteiro );

} /////// Frac ///////



/* Define qual a cor que sera usada no segmento que sera tracado. Calcula a
distancia entre o segmento e o centro da estrela.
****************************************************************************/
int Define_Cor ()
{
	static int
		CentroX = getmaxx () / 2,
		CentroY = getmaxy () / 2;

	int
		Base = abs ( CentroX - getx () ),
		Altura = abs ( CentroY - gety () ),
		Delta = Base * Base + Altura * Altura;

	if ( Delta < 0 ) Delta = - Delta;   // ERRO por aqui

	int
		Distancia = (int) sqrt (Delta),
		Cor = ( (int) ( Distancia / 3.75 ) ) + 64;

  return ( Cor );

} /////// Define_Cor ////////



/* Traca um segmento de reta relativo ao ponto atual com um certo angulo e um
 comprimento, desloca o ponto atual para o extremo oposto do segmento.
****************************************************************************/
void Vetor ( int Angulo, int Comprimento )
{
	static int
		SomaAngs = 0;
	double
		Radianos,
		Base,
		Altura;

	SomaAngs = ( SomaAngs + Angulo ) % 360;

	Radianos = (double) ( SomaAngs * (double) ( M_PI / 180 ) );
	Base = (double) ( cos ( Radianos ) * Comprimento + (double) Frac ( Base ) );
	Altura = (double) ( - sin ( Radianos ) * Comprimento + (double) Frac ( Altura ) );

	setcolor ( Define_Cor () );
	linerel ( (int) Base, (int) Altura );

} /////// Vetor ///////



/* Desenha estrela.
****************************************************************************/
void Faz_Estrela_de_Fogo ()
{
	for ( int Conta1 = 1; Conta1 <= 1800; Conta1 += 10 )
		for ( int Conta2 = Conta1 + 1; Conta2 <= 360 + Conta1; Conta2 += 10 )
			for ( int Conta3 = Conta2 + 1; Conta3 <= 360 + Conta2; Conta3 += 100 )
				Vetor ( Conta3 + 180, COMPRVETOR );

} /////// Faz_Estrela_de_Fogo ////////



/* Faz efeito de movimento com os tons de vermelho da estrela.
 Atribui o tom de vermelho de um registrador de cor anterior para um proximo.
****************************************************************************/
void Move_Palheta ()
{
	int
		ContaRegCor = 64,
		ContaSomaTom = 0,
		Cor;

	do                               // enquanto nao for teclado ESC
		while ( !kbhit () )           // enquanto nenhuma tecla for pressionada
			{
				Cor = ContaRegCor - 65 + ContaSomaTom;
				Cor = (Cor > 63) ? Cor - 63 : Cor;
				setrgbpalette ( ContaRegCor, Cor, 0, 0 );
				if ( ContaRegCor == 128 )
					{
						ContaRegCor = 64;
						if ( ContaSomaTom == 63 )
							ContaSomaTom = 0;
						else
							ContaSomaTom ++;
					}
				else
					ContaRegCor ++;
			}
	while ( getch () != 27 );
                              
} /////// Move_Palheta ////////


main ()
{
	Inicializa ();

	Altera_Palheta ( MONOCROM );

	Faz_Estrela_de_Fogo ();

	Altera_Palheta ( VERMELHOS );

	Move_Palheta ();

	closegraph ();
}