/* Cria efeito de cadeidoscopio com uma formula matematica e alteracao da
 palheta. 1024x768x256 */


#include <graphics.h>
#include <dos.h>
#include <math.h>
#include <iostream.h>
#include <conio.h>


int
	N_FORMULA = 1;
long
	DENOMINADOR_GRADIENTE = 12000000;


/* Faz pergunta ao usuario quanto a formula a ser usada.
****************************************************************************/
void Pergunta_Formula ()
{
	clrscr ();
	cout << "Demo Caleidoscopio 1." << "\n\n";
	cout << "Requer suporte para modo 1024x768 com 256 cores." << '\n';
	cout << "Voce deseja que o desenho seja gerado pelas formulas: 1, 2, 3 ou 4?" << '\n';
	cout << "A escolha da formula tambem define alteracoes em algumas variaveis do programa." << '\n';
	cout << "Teclando ESC voce aborta cada uma das partes do demo." << '\n';
	cin >> N_FORMULA;
	switch ( N_FORMULA )
		{
			case 2:
				DENOMINADOR_GRADIENTE = 100000;
				break;
			case 3:
				{
					DENOMINADOR_GRADIENTE = 1000000;
					N_FORMULA = 2;
					break;
				}
			case 4:
				{
					DENOMINADOR_GRADIENTE = 12000000;
					N_FORMULA = 2;
					break;
				}
			default:
				{
					DENOMINADOR_GRADIENTE = 12000000;
					N_FORMULA = 1;
					break;
				}
		}

} ///// Pergunta_Formula /////


/* Usado na definicao do modo grafico (Inicia_Modo_Grafico).
****************************************************************************/
int huge Detect4 ()
{
	return ( 4 );

} ///// Detect4 /////


/* Passa para o modo 1024x768x256 (modo 4).
****************************************************************************/
void Inicia_Modo_Grafico ()
{
	int
		GrDriver = DETECT,
		GrMode;

	installuserdriver ( "svga256", Detect4 );
	initgraph (&GrDriver, &GrMode, "");
	setgraphmode ( 4 );

} ///// Inicia_Modo_Grafico /////


/* Termina o modo grafico voltando ao de texto.
****************************************************************************/
void Termina_Modo_Grafico ()
{
	closegraph ();

} ///// Termina_Modo_Grafico /////


/* Expressao da formula que sera usada na definicao da figura.
 (X*X + Y*Y - 2*X) * (X*X + Y*Y - 2*X) - 2000*(X*X + Y*Y)
****************************************************************************/
long Formula ( int X, int Y )
{
	long
		XxX = (long) ( X * X ),
		YxY = (long) ( Y * Y ),
		XXmaisYY = (long) ( XxX + YxY );

	switch ( N_FORMULA )
		{
			case 1:
				{
					long
						XXmenosYY = (long) ( XxX - YxY );

					return ( (long) ( (long) ( (long) ( XXmenosYY * XXmaisYY ) - 2000 ) * ( (long) ( XXmenosYY + 20 ) ) ) );
					break;
				}
			case 2:
				{
					long
						XXmaisYYmenos2xX = (long) ( XXmaisYY - (long) ( 2 * X ) );

					return ( (long) ( (long) ( XXmaisYYmenos2xX * XXmaisYYmenos2xX ) - (long) ( 2000 * XXmaisYY ) ) );
					break;
				}
		}

} ///// Formula /////


/* Varre a tela calculando a cor de cada ponto.
****************************************************************************/
void Varre_Tela ()
{
	for ( int Y = 0; Y < 384; Y ++ )
		{
			for ( int X = 0; X < 512; X ++ )
				{
					int
						Valor_Ponto = 64 + abs ( (long) ( Formula ( X - 512, Y - 384 ) / DENOMINADOR_GRADIENTE ) % 64 );
					putpixel ( X, Y, Valor_Ponto );
					putpixel ( 512 - X + 511, Y, Valor_Ponto );
					putpixel ( X, 384 - Y + 383, Valor_Ponto );
					putpixel ( 512 - X + 511, 384 - Y + 383, Valor_Ponto );
				}
			if ( kbhit () && ( getch () == 27 ) )
				break;
		}

} ///// Varre_Tela /////


/* Atribui valores de cores que nao preto e branco para a palheta.
****************************************************************************/
void Atribui_Palheta ( int Espera )
{
	for ( int Conta = 64; Conta < 128; Conta ++ )
		{
			if ( kbhit () && ( getch () == 27 ) )
				break;
			delay ( Espera );
			setrgbpalette (Conta, 0, Conta, Conta);
		}

} ///// Atribui_Palheta /////


/* Atribui preto para todos os registradores de cor usados.
****************************************************************************/
void Apaga_Palheta ()
{
	for ( int Conta = 64; Conta < 128; Conta ++ )
		{
			if ( kbhit () && ( getch () == 27 ) )
				break;
			delay (50);
			setrgbpalette ( Conta, 0, 0, 0 );
		}

} /////// Apaga_Palheta ////////


/* Atribui branco para todos os registradores de cor usados.
****************************************************************************/
void Branqueia_Palheta ()
{
	for ( int Conta = 127; Conta >= 63; Conta -- )
		{
			if ( kbhit () && ( getch () == 27 ) )
				break;
			delay ( 50 );
			setrgbpalette ( Conta, 63, 63, 63 );
		}

} /////// Branqueia_Palheta ////////


main ()
{
	Pergunta_Formula ();
	Inicia_Modo_Grafico ();
	Atribui_Palheta ( 0 );
	Varre_Tela ();
	Apaga_Palheta ();
	Atribui_Palheta ( 90 );
	Branqueia_Palheta ();
	delay (100);
	Apaga_Palheta ();
	Termina_Modo_Grafico ();
}
