/* Desenha e move pontos e testa tecnicas de orientacao a objeto.
	Classes aninhadas:
	Estrelas < Galaxia < Universo */


#include <graphics.h>
#include <conio.h>                 // getch () e kbhit ()
#include <stdlib.h>                // random e randomize
#include <math.h>                  // seno e cosseno
#include <dos.h>

#define MAX_PONTOS 200
#define PROPVID 1


struct sFracao {                   // Acumula a parte fracionaria da soma do
	float                           // deslocamento de X e Y, respectivamente.
		X, Y;                        // E a taxa de incremento.
};


// Define um ponto: coordenadas, deslocamento, funcoes de movimentacao.
// Sera uma classe aninhada da classe Galaxia.
/////////////////////////////////////////////////////////////////////////////
class Estrela
{
	protected:

		int
			X, Y;
		sFracao
			SFrac_Coord,
			Incremento;

		void operator ++ ();         // marca a estrela
		void operator -- ();         // apaga a estrela

	public:

		Estrela ()                     // construtor
			{
				X = random ( getmaxx () );
				Y = random ( getmaxy () );
				int
					Angulo = random ( 360 );
				float
					Arads  = Angulo * M_PI / 180;  // calcula novas coordenadas
				Incremento.X = cos ( Arads );
				Incremento.Y = sin ( Arads ) / PROPVID;
				SFrac_Coord.X = 0;
				SFrac_Coord.Y = 0;
			}

		~Estrela ()                    // destrutor
			{
				(*this) --;
			}

		void Move ();

}; ////// class Estrela //////


/* Desenha o pixel definido em Estrela na tela.
****************************************************************************/
void Estrela::operator ++ ()
{
	putpixel ( X, Y, getmaxcolor () );

} ////// operator ++ ///////


/* Apaga o pixel definido em Estrela.
****************************************************************************/
void Estrela::operator -- ()
{
	putpixel (X, Y, 0);

} ///// operator -- //////


/* Desloca a estrela apagando, atualizando a sua posicao e desenhando denovo.
****************************************************************************/
void Estrela::Move ()
{
	// Apaga a estrela, this aponta para o objeto, -- eh um operador sobrecarr.
	(*this) --;

	// Soma as partes fracionarias da estrela.
	if ( ( SFrac_Coord.X >= 1 ) || ( SFrac_Coord.X <= -1 ) )
		SFrac_Coord.X = 0;
	else
		SFrac_Coord.X += Incremento.X;

	if ( ( SFrac_Coord.Y >= 1 ) || ( SFrac_Coord.Y <= -1 ) )
		SFrac_Coord.Y = 0;
	else
		SFrac_Coord.Y += Incremento.Y;

	// Faz com que a estrela que saiu dos limites da tela volte.
	X += ( X > getmaxx () ) ? ( -X + 1 ) : ( X < 1 ) ? ( getmaxx () ) : SFrac_Coord.X;
	Y += ( Y > getmaxy () ) ? ( -Y + 1 ) : ( Y < 1 ) ? ( getmaxy () ) : SFrac_Coord.Y;

	(*this) ++;

}  /////// Move //////


// Define o grupo de Estrelas como uma Galaxia. Varias galaxias formam Universo
/////////////////////////////////////////////////////////////////////////////
class Galaxia
{
	protected:
		int
			N_Estrelas;
		Estrela
			*E [MAX_PONTOS];

	public:

		Galaxia ( int N )  // o parametro N eh atribuido a N_Estrelas
			{
				N_Estrelas = N;
				for ( int Conta = 0; Conta < N_Estrelas; Conta ++ )
					E [Conta] = new Estrela;
			}

		~Galaxia ()
			{
				for ( int Conta = 0; Conta < N_Estrelas; Conta ++ )
					delete E [Conta];
			}

		void Movimenta ();

}; ///// class Galaxia //////


/* Move as estrelas da galaxia de lugar.
****************************************************************************/
void Galaxia::Movimenta ()
{
	for ( int Conta = 0; Conta < N_Estrelas; Conta ++ )
		E [Conta] -> Move ();

}  /////// Movimenta //////


// Define um Universo atraves de um certo numero de galaxias.
/////////////////////////////////////////////////////////////////////////////
class Universo
{
	public:

		Universo ( int Espera )
			{
				Galaxia
					*Via_Lactea,
					*KV11;

				Via_Lactea = new Galaxia (30);
				KV11 = new Galaxia (20);
				while ( kbhit() == 0 )
					{
						delay (Espera);
						Via_Lactea -> Movimenta ();
						KV11 -> Movimenta ();
					}

				getch ();
				delete Via_Lactea;
				delete KV11;
			}

}; ///// class Universo /////



main ()
{
	int
		GrDriver = DETECT,
		GrMode;
	initgraph (&GrDriver, &GrMode, "");

	randomize ();

	Universo
		U (10);

	closegraph ();
}